#!/usr/bin/perl
#
#      Suck.pl - console news client
#
#      Copyright (c) 2003 CryptoManceR
#
#      You may distribute under the terms of GNU GPL.
#
#      Start options:
#      -g group.name
#      -d days_old
#      -s server.name
#      -u username
#      -p password

require News::NNTPClient;
use Date::Parse;
use Getopt::Std;

$n=0 ; $l=1;

require "suck.cfg";

getopt('sgdup');

trace ( "Connecting to server: ",$opt_s);

for ($i = 0; $i <= $links; $i++) { openlink (@c[$i]); }
openlink ($ctrl);

$curr=$last;
print STDERR "Group: ", $opt_g,"\n";
print STDERR "Oldest: ", @c[0]->xhdr("Date",$first);
print STDERR "Newest: ", @c[0]->xhdr("Date",$last);
print STDERR "Totally: ", $last-$first,"\n";

open (GRP,">".$opt_g.".".sprintf("%04d-%02d-%02d-%02d-%02d",sub{1900+$_[5],$_[4]+1,$_[3],$_[2],$_[1],}->(localtime)).".txt") || die "Can't write to file";

$rotten = time - $opt_d * 84000;

do {
 $n=0 ;
 @dates=$ctrl->xhdr("Date",$curr-$block,$curr);
  %dates = (0,0);
  foreach ( @dates ) { $dates{getnum($_)}=chompnum($_) ; };
 @subjs=$ctrl->xhdr("Subject",$curr-$block,$curr);
  %subjs = (0,0);
  foreach ( @subjs ) { $subjs{getnum($_)}=chompnum($_) ; };
 @froms=$ctrl->xhdr("From",$curr-$block,$curr);
  %froms = (0,0);
  foreach ( @froms ) { $froms{getnum($_)}=chompnum($_) ; };

  foreach ( reverse @dates ) { 
    $msgdate = chompnum($_);
    $msgnum = getnum($_);
    $msgunixtime = str2time($msgdate);
    if ( $msgunixtime>$rotten ) 
       { $hdr="Date: ".$dates{$msgnum}."From: ".$froms{$msgnum}."Subject: ".$subjs{$msgnum};
         getmsg($msgnum,$hdr) 
       } else { print STDERR "X"; };
  }
 $curr=$curr-$block-1;
 print STDERR "!";
} while ($n>0);

for ($i = 0; $i <= $links; $i++) { getmsg(0); };
for ($i = 0; $i <= $links; $i++) { @c[$i]->quit; }; $ctrl->quit;
close GRP ;

sub getmsg {
#	trace($l." ".$n." ".@m[$l]." ".$_[0]);
  if ( defined(@m[$l]) ) {
    print GRP @m[$l] ;
    @c[$l]->response;
    print GRP @c[$l]->fetch,"\n-------------\n";
   }
  if ( $_[0]>0 ) { 
    print STDERR "."; 
    @c[$l]->cmd("BODY $_[0]"); 
    @m[$l]=$_[1];
   }   
    $n=$n+1; $l=$l+1; if ($l>$links) { $l=1 };
}

sub openlink {
 $_[0] = new News::NNTPClient($opt_s);
 if (defined($opt_u)) 
   { $_[0]->authinfo($opt_u,$opt_p
); }
 ($first, $last ) = ( $_[0]->group($opt_g) ); }

sub chompnum { return substr($_[0], index($_[0]," ")+1); };
sub getnum { return substr($_[0], 0, index($_[0]," ")); };
sub trace { print STDERR $_[0],$_[1],$_[2],"\n"; };
